package gra;

import java.awt.Graphics;
import java.util.HashSet;
import java.util.Random;
import java.util.Set;
import javax.swing.JPanel;
import javax.swing.Timer;

public class Plansza extends JPanel {
    private Set<Jablko> jablka = new HashSet<>();
    private Random random = new Random();
    // w milisekundach - co jaki czas ma być odświeżony ekran
    private int pauza = 1000;

    // o ile pikseli jablka spadaja w jednym ruchu
    private int skok = 20;

    private double prawdopodobienstwoNowegoJablka = 0.5;

    private Timer timer = new Timer(pauza, (evt) -> {
        jedenKrok();
    });

    public Plansza() {
        timer.start();
    }

    @Override
    protected void paintComponent(Graphics g) {
        super.paintComponent(g);
        for(Jablko jablko : jablka) {
            jablko.narysujSie(g);
        }
    }

    // tresc tej metody bedzie wykonywana cyklicznie co okreslony czas przez timera
    void jedenKrok() {
        for(Jablko jablko : jablka) {
            jablko.opusc(skok);
        }
        if(random.nextDouble() < prawdopodobienstwoNowegoJablka) {
            int x = random.nextInt(this.getWidth() - Jablko.SREDNICA);
            int y = 0;
            Jablko noweJablko = new Jablko(x, y);
            jablka.add(noweJablko);
        }
        this.repaint();
    }

    public int getPauza() {
        return pauza;
    }

    public void setPauza(int pauza) {
        this.pauza = pauza;
        timer.setDelay(pauza);
    }

    public int getSkok() {
        return skok;
    }

    public void setSkok(int skok) {
        this.skok = skok;
    }

    public double getPrawdopodobienstwoNowegoJablka() {
        return prawdopodobienstwoNowegoJablka;
    }

    public void setPrawdopodobienstwoNowegoJablka(double prawdopodobienstwoNowegoJablka) {
        this.prawdopodobienstwoNowegoJablka = prawdopodobienstwoNowegoJablka;
    }


}
